<template>
  <v-container fluid>
    <v-card
      class="mx-auto"
      :loading="!foundArchiveData"
    >
      <v-hover
        v-slot="{ hover }"
      >
        <v-expand-transition>
          <v-img
            style="transition: height 500ms"
            :src="$toCDN(foundArchiveData.note)"
            :height="hover ? '400px' : '200px'"
          />
        </v-expand-transition>
      </v-hover>

      <template v-if="foundArchiveData">
        <v-card-title class="mb-3">
          {{ foundArchiveData.title }}
        </v-card-title>

        <!-- <v-card-subtitle>{{ foundArchiveData.note }} </v-card-subtitle> -->

        <v-card-text>
          <div class="text-subtitle-1">
            <p class="mr-5">
              <small>Keywords:</small>
            </p>
            <v-chip
              v-for="(currTag, tagKey) in foundArchiveData.tags"
              :key="tagKey"
              class="mr-1"
              small
            >
              {{ currTag }}
            </v-chip>
          </div>
        </v-card-text>

        <v-card-text>
          <div class="text-subtitle-1">
            <p class="mr-5">
              <small>Authors:</small>
            </p>
            <v-chip
              v-for="(currItem, itemKey) in foundArchiveData.authors"
              :key="itemKey"
              class="mr-1"
              small
            >
              {{ currItem.name }}
            </v-chip>
          </div>
        </v-card-text>

        <v-card-text>
          <div class="text-subtitle-1">
            <p class="mr-5">
              <small>Published Date:</small>
            </p>

            {{ foundArchiveData.published_date | $humanDate }}
          </div>
        </v-card-text>

        <template v-if="authUser">
          <v-divider />

          <v-card-actions class="pa-3 d-flex justify-end">
            <v-btn
              color="primary"
              @click="handleClickDownloadFile"
            >
              Download
            </v-btn>
          </v-card-actions>
        </template>
      </template>
    </v-card>
  </v-container>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { mapActions, mapGetters, mapState, mapMutations } from 'vuex'

export default {
  name: 'ArchiveDetails',

  data () {
    return {
      selection: 1
    }
  },

  computed: {
    ...mapState('archives', {
      foundArchiveData: 'foundData'
    }),

    ...mapState('users', {
      authUser: 'authUser'
    })
  },

  async created () {
    await this.bootstrap()
    console.log('asdfasdf')
  },

  methods: {
    ...mapActions('archives', {
      findArchive: 'find'
    }),

    handleClickDownloadFile () {
      const uri = this.$toCDN(this.foundArchiveData.path)

      this.$download(uri)
    },

    async bootstrap () {
      try {
        await this.findArchive(this.$route.params.id)
      } catch (error) {
        console.log(error)
      }
    }
  }
}
</script>
